close all;
clear all;
clc;

%% Load .MAT
loadFile = 'testFiles/test6.mat';
load(loadFile)

%% Split Variables
time = outPut(1,:);

ax = outPut(2:5,:);
ay = outPut(6:9,:);
az = outPut(10:13,:);

gx = outPut(14:17,:);
gy = outPut(18:21,:);
gz = outPut(22:25,:);


gx(4,:) = gx(4,:)-gx(4,1);

%% print FIG
figure('Name', 'IMU #1','NumberTitle','off');
subplot(1,2,1)
    title('Accelerometer');
    hold on
    plot(time, ax(1,:), 'Color', 'r')
    plot(time, ay(1,:), 'Color', 'b')
    plot(time, az(1,:), 'Color', 'g')
    hold off
    legend('Ax','Ay','Az')
    %xlim([0 runTime/sample])
    xlabel('Time [s]');
    ylabel('m/s2');

subplot(1,2,2)
    title('Gyro');
    hold on
    plot(time, gx(1,:), 'Color', 'r')
    plot(time, gy(1,:), 'Color', 'b')
    plot(time, gz(1,:), 'Color', 'g')
    hold off
    legend('Gx','Gy','Gz')
    %xlim([0 runTime/sample])
    xlabel('Time [s]');
    ylabel('°/s');

movegui(1,[200,600])


figure('Name', 'IMU #3','NumberTitle','off');
subplot(1,2,1)
    title('Accelerometer');
    hold on
    plot(time, ax(3,:), 'Color', 'r')
    plot(time, ay(3,:), 'Color', 'b')
    plot(time, az(3,:), 'Color', 'g')
    hold off
    legend('Ax','Ay','Az')
    %xlim([0 runTime/sample])
    xlabel('Time [s]');
    ylabel('m/s2');

subplot(1,2,2)
    title('Gyro');
    hold on
    plot(time, gx(3,:), 'Color', 'r')
    plot(time, gy(3,:), 'Color', 'b')
    plot(time, gz(3,:), 'Color', 'g')
    hold off
    legend('Gx','Gy','Gz')
    %xlim([0 runTime/sample])
    xlabel('Time [s]');
    ylabel('°/s');

movegui(2,[750,600])



figure('Name', 'IMU #4','NumberTitle','off');
subplot(1,2,1)
    title('Accelerometer');
    hold on
    plot(time, ax(4,:), 'Color', 'r')
    plot(time, ay(4,:), 'Color', 'b')
    plot(time, az(4,:), 'Color', 'g')
    hold off
    legend('Ax','Ay','Az')
    %xlim([0 runTime/sample])
    xlabel('Time [s]');
    ylabel('m/s2');

subplot(1,2,2)
    title('Gyro');
    hold on
    plot(time, gx(4,:), 'Color', 'r')
    plot(time, gy(4,:), 'Color', 'b')
    plot(time, gz(4,:), 'Color', 'g')
    hold off
    legend('Gx','Gy','Gz')
    %xlim([0 runTime/sample])
    xlabel('Time [s]');
    ylabel('°/s');

movegui(3,[200,100])



figure('Name', 'IMU #2','NumberTitle','off');
subplot(1,2,1)
    title('Accelerometer');
    hold on
    plot(time, ax(2,:), 'Color', 'r')
    plot(time, ay(2,:), 'Color', 'b')
    plot(time, az(2,:), 'Color', 'g')
    hold off
    legend('Ax','Ay','Az')
    %xlim([0 runTime/sample])
    xlabel('Time [s]');
    ylabel('m/s2');

subplot(1,2,2)
    title('Gyro');
    hold on
    plot(time, gx(2,:), 'Color', 'r')
    plot(time, gy(2,:), 'Color', 'b')
    plot(time, gz(2,:), 'Color', 'g')
    hold off
    legend('Gx','Gy','Gz')
    %xlim([0 runTime/sample])
    xlabel('Time [s]');
    ylabel('°/s');

movegui(4,[750,100])


%% PWELCH
% Analyzing gyro signal:
sampleTime = length(outPut) / outPut(1,end);

% IMU # 1
[pwGx1, fx1] = pwelch(gx(1,:),[],[],[], sampleTime);
[pwGy1, fy1] = pwelch(gy(1,:),[],[],[], sampleTime);
[pwGz1, fz1] = pwelch(gz(1,:),[],[],[], sampleTime);

% IMU # 2
[pwGx2, fx2] = pwelch(gx(2,:),[],[],[], sampleTime);
[pwGy2, fy2] = pwelch(gy(2,:),[],[],[], sampleTime);
[pwGz2, fz2] = pwelch(gz(2,:),[],[],[], sampleTime);

% IMU # 3
[pwGx3, fx3] = pwelch(gx(3,:),[],[],[], sampleTime);
[pwGy3, fy3] = pwelch(gy(3,:),[],[],[], sampleTime);
[pwGz3, fz3] = pwelch(gz(3,:),[],[],[], sampleTime);

% IMU # 4
[pwGx4, fx4] = pwelch(gx(4,:),[],[],[], sampleTime);
[pwGy4, fy4] = pwelch(gy(4,:),[],[],[], sampleTime);
[pwGz4, fz4] = pwelch(gz(4,:),[],[],[], sampleTime);

figure(5)
plot(f

%% EOF