 % TPK4560 - Project-modellation
 % Author:  Aslak J. Strand
 % Purpose: Initiation file go generate a simscape model

%% Function Call:
function createRobotModel(runTest,urdfFile)
    Crane = importrobot(urdfFile);

    % If initialized with runTest=true:
    %   Don't build simulink model
    %   Show robot model as figures
    %   Used as help with writing urdf file
    % ELSE
    %   Port urdf-model to simulink
    
    if runTest
        figure(1)
        subplot(2,1,1)
        show(Crane,'visuals','on','collision','off');
        Crane.DataFormat = 'row';

        showdetails(Crane)
        Crane.BodyNames

        randConfig = Crane.randomConfiguration

        tform = getTransform(Crane,randConfig,'H3','L1');
        ik = inverseKinematics('RigidBodyTree',Crane);

        weights = [0.25 0.25 0.25 1 1 1];
        initialguess = Crane.homeConfiguration;

        [configSoln,solnInfo] = ik('L4',tform,weights,initialguess);
        subplot(2,1,2)
        show(Crane,configSoln);

    else
        smimport(urdfFile)
    end

end