%% TPK4560 - Project-modellation
 % Author:  Aslak J. Strand
 % Purpose: Initiation file for model simulation
 
 % Future research and simulation tweaks will yield
 % more data in the initiation file. 
 
 % As of now a few values are needed. 
 % This file may also generate crane simulation file if needed.
 
%% Clearing workspace:
clearvars; close all; clc

% Choose whether to read from URDF or not, 
% and if testbuild or port to simulink
generateModel   = false;
    testRun     = false;
    modelImport = true;
    openSim     = true;

%% Basic model values
% Rotasjonsmatrise = Orthonormal matrix
% Se på skipet: miljøkrefter
%     Få med skip -> få med miljøkrefter på skip
%     Få med miljøkrefter på kran/last

configSequence = [0, 0, 0];
poseWeights = [0, 0, 0, 0];



%% Fountation:  (Body 1)
    % Select valid option: 
    % 1 - Fixed foundation
    % 2 - Large ship
    % 3 - Small ship

base = 1;

if base == 1        % Fixed
%     m1 = 10000;
elseif base == 2    % Large
    % Not implemented
elseif base == 3    % Small
    % Not implemented
end


%% Tower:       (Body 2)
m2      = 100;     % [kg]
r2      = 0.02;     % [m]
h2      = 5;       % [m]


%% Main Boom:   (Body 3)
% m3      = 20;       % [kg]
% L3      = 0.5;      % [m]

%% Outer Boom:  (Body 4)
% m4      = 17;       % [kg]
% L4      = 0.4;      % [m]


%% Generate model:
if generateModel
    myURDFfile  = 'craneSim.urdf';
    %myURDFfile  = 'SINTEFcrane.urdf';
    createRobotModel(testRun,myURDFfile)
end
if modelImport
    open_system('craneRBT.slx');
    [robot,importInfo] = importrobot(gcs);
    close_system('craneRBT.slx');
end

%FExt = externalForce(robot,'robot',[0 0 0.0 0.1 0 0]);
FExt = [0.1, 0.1, 0.1, 0.1, 0.1;
    0.1, 0.1, 0.1, 0.1, 0.1;
    0.1, 0.1, 0.1, 0.1, 0.1;
    0.1, 0.1, 0.1, 0.1, 0.1;
    0.1, 0.1, 0.1, 0.1, 0.1;
    0.1, 0.1, 0.1, 0.1, 0.1];

if openSim
    open_system('Crane.slx');
end

%% Include Real Disturbance:
load('/Users/straslak/Desktop/Skole/NTNU_Master/03_Semester/TPK4560-Fordypning/Project/MatLab/figures/master_test/gyr_60.mat');
timeVals = 0:(3600/length(Gyr_60min)):3600;
dist = timeseries(Gyr_60min', timeVals(2:end));

%% EOF